#  Projet Puissance-4 Printemps 2021-2022
#  Date de rendu: 13/03/2022
#  GHAMAT et LAU, TP/TD1_S3/Informatique

################################################################################################################################# 
##  Ce fichier contient un squelete de code pour le jeu du puissance 4.
##  L'ensemble des fonctions d'affichage est déjà en place. L'affichage repose sur l'écriture de carrés de 8x8px.
##  Les fonctions à compléter sont les suivantes :
##  
#################################################################################################################################
.data

grilleJeu: .byte 0:42 #ce tableau va representer la grille du jeu : 0 = vide,   1 = Player1,  2 = Player2

tableauCouleur: .byte 0:2 #ce tableau est pour des couleurs 

Colors:	#  Contient les couleurs
 .word 0x0000FF # [0] Bleu   0x0000FF	Grille
 .word 0xFF0000 # [1] Rouge  0xFF0000	Jeton joueur 
 .word 0xE5C420 # [2] Jaune  0xE5C420	Jeton joueur 
 .word 0x000000 # [3] Noir   0x000000	Jeton joueur
 .word 0x4A235A # [4] Violet 0x4A235A	Jeton joueur
 .word 0x186A3B # [5] Vert   0x186A3B	Jeton joueur 
 .word 0xFFFFFF # [6] Blanc  0xFFFFFF	Fond



#  Un cercle est définit par une suite de lignes horizontales.
#  Chaque ligne est définie par un offset suivit d'une longeur (ex : 2, 4, on décale de deux carrés et on déssine 4 carrés
CircleDef: 
	.word 2, 4, 1, 6, 0, 8, 0, 8, 0, 8, 0, 8, 1, 6, 2, 4
	     
displayStart: .asciiz "Bienvenue dans ce jeu du puissance 4!\nC'est un jeu à deux joueurs.\nLe joueur 1 va commencer.\nEntrez un nombre entre 1 et 7 pour choisir la colonne où jouer.\nUne fois qu'un joueur a joué, attendez que la console demande une nouvelle action pour jouer!\n\nBon Jeu!\n\n"
displayP1: .asciiz "\nTour du joueur 1 : "
displayP2: .asciiz "\nTour du joueur 2 : "
displayP3: .asciiz "\nCleaning : "
displayP1Win: .asciiz "Le joueur 1 à gagné !\n"
displayP2Win: .asciiz "Le joueur 2 à gagné !\n"
displayInstructions: .asciiz "Choisissez un nombre entre 1 et 7 (inclus)\n"
displayFull: .asciiz "la colonne choisie est pleine. Choisissez en une autre.\n"
displayTie: .asciiz "Il y a égalité !\n"
displayRestart: .asciiz "Voulez-vous recommencer le jeu? si oui, saisissez 1, sinon 0 \n"
displayCouleur: .asciiz "Choisissez une couleur en saisissant un numéro, le joueur 1 Commence d'abord : Rouge[1], Jaune[2], Noir[3], Violet[4], Vert[5]  \n"
displayCouleur2: .asciiz "Choisissez une couleur en saisissant un numéro, le joueur 2 : Rouge[1], Jaune[2], Noir[3], Violet[4], Vert[5]  \n"
displayCouleurInstruction: .asciiz "Ce numéro n'est pas une couleur de jeton, veuillez saisir l'un de ces numéros pour la couleur, Rouge[1], Jaune[2], Noir[3], Violet[4], Vert[5] \n"
displayRestartInstruction: .asciiz "Ce numéro n'est pas un numéro pour recommencer le jeu ou non, veuillez saisir 1 pour recommencer le jeu, sinon 0. \n"

.text

#  Déssine le plateau
jal DrawGameBoard

choisirCouleur:
	#  Début du jeu
	la $a0, displayStart	
	li $v0, 4                       # Affiche le Bienvenue
	syscall
        
        reChoisirCouleur:
	# Demande de saisir la couleur du jeton, joueur 1 
	la $a0, displayCouleur	
	li $v0, 4                       # Affiche: Choisissez une couleur en saisissant un numéro, le joueur 1 Commence d'abord : Rouge[1], Jaune[2], Noir[3], Violet[4], Vert[5]
	syscall

	li $v0, 5                       # Lecture de la saisie pour la couleur du jeton, jouer 1
	syscall
	bgt $v0, 5, DepassementCouleur  # Si le $v0 est supérieur à 5 alors, ce n'est pas une couleur de jeton
	ble $v0, 0, DepassementCouleur  # Si le $v0 est infèrieur à 1 alors, ce n'est pas une couleur de jeton
	li $t5 0                        # Mettre l'indice 0 pour le premier élément du tableau
	sb $v0 tableauCouleur($t5)      # Prendre la valeur du tableau de couleur à l'indice 0
        
        reChoisirCouleur2:
	# Demande de saisir la couleur du jeton, joueur 2
	la $a0, displayCouleur2	
	li $v0, 4                        # Affiche: Choisissez une couleur en saisissant un numéro, le joueur 2 : Rouge[1], Jaune[2], Noir[3], Violet[4], Vert[5]
	syscall

	li $v0, 5                        # Lecture de la saisie pour la couleur du jeton joueur 2
	syscall
	bgt $v0, 5, DepassementCouleur2  # Si le $v0 est supérieur à 5 alors, ce n'est pas une couleur de jeton
	ble $v0, 0, DepassementCouleur2  # Si le $v0 est infèrieur à 1 alors, ce n'est pas une couleur de jeton
	li $t5 1                         # Mettre l'indice 1 pour le deuxième élément du tableau
	sb $v0 tableauCouleur($t5)       # Prendre la valeur du tableau de couleur à l'indice 1
        jal main                         # Saut vers main
        
	DepassementCouleur:
	la $a0, displayCouleurInstruction	
	li $v0, 4                        # Affiche: Ce numéro n'est pas une couleur de jeton, veuillez saisir l'un de ces numéros pour la couleur, Rouge[1], Jaune[2], Noir[3], Violet[4], Vert[5]
	syscall
	jal reChoisirCouleur             # Continuer la boucle pour rechoisir la couleur 
	
	DepassementCouleur2:
	la $a0, displayCouleurInstruction	
	li $v0, 4                        # Affiche: Ce numéro n'est pas une couleur de jeton, veuillez saisir l'un de ces numéros pour la couleur, Rouge[1], Jaune[2], Noir[3], Violet[4], Vert[5]
	syscall
	jal reChoisirCouleur2            # Continuer la boucle pour rechoisir la couleur
	


################################   Fonction Main ################################ 
main: 

#  Récupère l'instruction du joueur 1
playerOne:

# Affiche: Tour du joueur 1
la $a0, displayP1          
li $v0, 4                   # Afficher
syscall

li $v0, 5                   # Lecture de la saisie
syscall

#  Place le jeton et contrôle s'il y a une erreur
li $a0, 1                   # Mettre le numéro du joueur (1) dans $a0
jal UpdateRecord            # Fait un saut à l'adresse UpdateRecord 

#  Déssine le jeton
li $t5 0                    # Ajouter 0 comme l'indice
lb $a0, tableauCouleur($t5) # Ajouter la première valeur du tableau de couleur 
jal DrawPlayerChip


#  Test si le joueur 2 a gagné
li $a0, 1                   # Remettre 1 pour indiquer que c'est le joueur 1
jal WinCheck

#  Récupère l'instruction du joueur 2
playerTwo:
# Affiche Tour du joueur 2
la $a0, displayP2   
li $v0, 4                   # Afficher
syscall

li $v0, 5                   # Lecture de la saisie
syscall

#  Place le jeton et contrôle s'il y a une erreur
li $a0, 2                   # Mettre le numéro du joueur (1) dans $a0
jal UpdateRecord            # Faire un saut à l'adresse UpdateRecord 

#  Déssine le jeton
li $t5 1                    # Ajouter 1 comme l'indice
lb $a0, tableauCouleur($t5) # Ajouter la deuxième valeur du tableau de couleur
jal DrawPlayerChip


#  Test si le joueur 2 à gagné
li $a0, 2                   # Remettre 2 pour indiquer que c'est le joueur 2 
jal WinCheck                # Faire un saut à l'adresse UpdateRecord

j main	                    #  Passer au prochain tour
################################   Fin de la fonction Main ################################  



################################   Début des procédures d'affichage ################################  
##################### Il n'est pas obligatoire de comprendre ce qu'elles font. ##################### 
# Procedure: DrawPlayerChip
# Input: $a0 - Numéro du joueur
# Input: $v0 - Position (entre 0 et 41)
DrawPlayerChip:
	
	addiu $sp, $sp, -12
	sw $ra, ($sp)
	sw $a0, 4($sp)
	sw $v0, 8($sp)
	
	#  place la couleur du jeton en argument
	move $a2, $a0
	
	#  On calcul la position
	li $t0, 7
	div $v0, $t0
	mflo $t0	# Division (Y)
	mfhi $t1	# Reste (X)

	#  Y-Position = 63-[(Y+1)*9+4] = 50-9Y (dans $t0)
	li $t2, 50
	mul $t0, $t0, 9
	mflo $t0
	sub $t0, $t2, $t0 
	
	# X-Position = [X*9]+1 (dans $t1)
	mul $t1, $t1, 9
	addi $t1, $t1, 1
	
	#  Copie les positions dans les registres d'arguments
	move $a0, $t1
	move $a1, $t0
	
	jal DrawCircle
	
	lw $v0, 8($sp)
	lw $a0, 4($sp)
	lw $ra, ($sp)
	addiu $sp, $sp, 4
	jr $ra

# Procedure: DrawGameBoard
# Affiche la grille
DrawGameBoard:
	addiu $sp, $sp, -4
	sw $ra, ($sp)
	
	#  Fond en blanc
	li $a0, 0
	li $a1, 0
	li $a2, 6	#indice couleur blanc
	li $a3, 64
	jal DrawSquare #  Affiche un carré blanc de 64x64 en position 0,0)
	
	#  Ligne du haut
	li $a0, 0	
	li $a1, 0	
	li $a2, 0	
	li $a3, 64	
	jal DrawHorizontalLine
	li $a1, 1
	jal DrawHorizontalLine
	li $a1, 2	
	jal DrawHorizontalLine
	li $a1, 3	
	jal DrawHorizontalLine
	li $a1, 4	
	jal DrawHorizontalLine
	
	#  Ligne du bas
	li $a0, 0	
	li $a1, 58	
	li $a2, 0	
	li $a3, 64	
	jal DrawHorizontalLine
	li $a1, 59
	jal DrawHorizontalLine
	li $a1, 60	
	jal DrawHorizontalLine
	li $a1, 61	
	jal DrawHorizontalLine
	li $a1, 62	
	jal DrawHorizontalLine
	li $a1, 63	
	jal DrawHorizontalLine


	#  Lignes verticales
	li $a0, 0	
	li $a1, 0	
	li $a2, 0	
	li $a3, 64	
	jal DrawVerticalLine	
	li $a0, 9	# (X = 9)
	jal DrawVerticalLine
	li $a0, 18	# (X = 18)
	jal DrawVerticalLine
	li $a0, 27	# (X = 27)
	jal DrawVerticalLine
	li $a0, 36	# (X = 36)
	jal DrawVerticalLine
	li $a0, 45	# (X = 45)
	jal DrawVerticalLine
	li $a0, 54	# (X = 54)
	jal DrawVerticalLine
	li $a0, 63	# (X = 63)
	jal DrawVerticalLine

	#  Lignes horizontales
	li $a0, 0	
	li $a1, 13	
	li $a2, 0	
	li $a3, 64	
	jal DrawHorizontalLine
	li $a1, 22
	jal DrawHorizontalLine
	li $a1, 31	
	jal DrawHorizontalLine
	li $a1, 40	
	jal DrawHorizontalLine
	li $a1, 49	
	jal DrawHorizontalLine

	lw $ra, ($sp)
	addiu $sp, $sp, 4
	jr $ra


# Procedure: DrawCircle
# Input - $a0 = X 
# Input - $a1 = Y
# Input - $a2 = Color (0-5)
# Affiche le Jeton
DrawCircle:
	#  Fait de a place sur la pile
	addiu $sp, $sp, -28 	
	#  Y ajoute les arguments suivants $ra, $s0, $a0, $a2
	sw $ra, 20($sp)
	sw $s0, 16($sp)
	sw $a0, 12($sp)
	sw $a2, 8($sp)
	li $s2, 0	#  Initaitllise le compteur et on passe dans la boucle de la fonction
	
CircleLoop:
	la $t1, CircleDef
	#  Utilise le compteur pour récupéer le bon indice dans CircleDef
	addi $t2, $s2, 0	
	mul $t2, $t2, 8		
	add $t2, $t1, $t2	
	lw $t3, ($t2)		
	add $a0, $a0, $t3	
	
	#  On déssine la ligne
	addi $t2, $t2, 4	
	lw $a3, ($t2)		
	sw $a1, 4($sp)		
	sw $a3, 0($sp)		
	sw $s2, 24($sp)		
	jal DrawHorizontalLine
	
	#  On remet en place les arguments
	lw $a3, 0($sp)
	lw $a1, 4($sp)
	lw $a2, 8($sp)
	lw $a0, 12($sp)
	lw $s2, 24($sp)
	addi $a1, $a1, 1	#  Incremente Y value
	addi $s2, $s2, 1	#  Incremente le compteur
	bne $s2, 8, CircleLoop	#  On boucle pour écrire les 8 lignes
	
	
	#  Réstaure les valeurs de $ra, $s0, $sp
	lw $ra, 20($sp)
	lw $s0, 16($sp)
	addiu $sp, $sp, 28
	jr $ra
	
# Procedure: DrawSquare
# Input - $a0 = X 
# Input - $a1 = Y
# Input - $a2 = Color (0-5)
# Input - $a3 = W 
# Déssine un carré de taille WxW en position (X, Y)
DrawSquare:
	addiu $sp, $sp, -24 	# Sauvegarde $ra, $s0, $a0, $a2
	sw $ra, 20($sp)
	sw $s0, 16($sp)
	sw $a0, 12($sp)
	sw $a2, 8($sp)
	move $s0, $a3		
	
BoxLoop:
	sw $a1, 4($sp)	
	sw $a3, 0($sp)	
	jal DrawHorizontalLine
	
	# Réstaure $a0-3
	lw $a3, 0($sp)
	lw $a1, 4($sp)
	lw $a2, 8($sp)
	lw $a0, 12($sp)
	addi $a1, $a1, 1	# Incrémente Y 
	addi $s0, $s0, -1	# Décrémente le nombre de ligne
	bne $zero, $s0, BoxLoop	# Jusqu'à ce que le compteur soit à zéro
	
	# Réstaure $ra, $s0, $sp
	lw $ra, 20($sp)
	lw $s0, 16($sp)
	addiu $sp, $sp, 24	# Reset $sp
	jr $ra
	
# Procedure: DrawHorizontalLine
# Input - $a0 = X 
# Input - $a1 = Y
# Input - $a2 = Color (0-5)
# Input - $a3 = W
# Déssine une ligne horizontale de longueur W en position (X, Y)
DrawHorizontalLine:
	addiu $sp, $sp, -28 	
	# Sauvegarde $ra, $a1, $a2
	sw $ra, 16($sp)
	sw $a1, 12($sp)
	sw $a2, 8($sp)
	sw $a0, 20($sp)
	sw $a3, 24($sp)
	
HorizontalLoop:
	# Sauvegarde $a0, $a3 
	sw $a0, 4($sp)
	sw $a3, 0($sp)
	jal DrawPixel
	# Réstaure tout sauf $ra
	lw $a0, 4($sp)
	lw $a1, 12($sp)
	lw $a2, 8($sp)
	lw $a3, 0($sp)	
	addi $a3, $a3, -1		# Décrémente la longueur W
	addi $a0, $a0, 1		# Incrémente X 
	bnez $a3, HorizontalLoop	# Boucle tant que W > 0 	
	lw $ra, 16($sp)			# Réstaure $ra
	lw $a0, 20($sp)
	lw $a3, 24($sp)
	addiu $sp, $sp, 28		# Réstaure $sp
	jr $ra
	
# Procedure: DrawVerticalLine
# Input - $a0 = X 
# Input - $a1 = Y
# Input - $a2 = Color (0-5)
# Input - $a3 = W
# Déssine une ligne verticale de longeur W en position (X, Y)
DrawVerticalLine:
	addiu $sp, $sp, -28
	# Sauvegarde $ra, $a1, $a2
	sw $ra, 16($sp)
	sw $a1, 12($sp)
	sw $a2, 8($sp)
	sw $a0, 20($sp)
	sw $a3, 24($sp)
	
VerticalLoop:
	# Save $a0, $a3 (changes with next procedure call)
	sw $a1, 4($sp)
	sw $a3, 0($sp)
	jal DrawPixel
	# Restore all but $ra
	lw $a1, 4($sp)
	lw $a0, 20($sp)
	lw $a2, 8($sp)
	lw $a3, 0($sp)	
	addi $a3, $a3, -1		# Décrémente la longueur W
	addi $a1, $a1, 1		# Incrémente Y 
	bnez $a3, VerticalLoop		# Boucle tant que W > 0 	
	lw $ra, 16($sp)			# Réstaure $ra
	lw $a1, 12($sp)
	lw $a3, 24($sp)
	addiu $sp, $sp, 28		# Réstaure $sp
	jr $ra
	
# Procedure: DrawPixel
# Input - $a0 = X
# Input - $a1 = Y
# Input - $a2 = Color (0-5)
# Déssine un pixel sur la Bitmap en écrivant au bon endroit sur la mémoire (sur le tas/heap) via la fonction GetAddress
DrawPixel:
	addiu $sp, $sp, -8
	# Save $ra, $a2
	sw $ra, 4($sp)
	sw $a2, 0($sp)
	jal GetAddress		# Calcule l'adresse mémoire
	lw $a2, 0($sp)		
	sw $v0, 0($sp)		
	jal GetColor		# Récupère la couleur
	lw $v0, 0($sp)		
	sw $v1, ($v0)		# Ecrit la couleur en mémoire
	lw $ra, 4($sp)		
	addiu $sp, $sp, 8	
	jr $ra


# Procedure: GetAddress
# Input - $a0 = X
# Input - $a1 = Y
# Output - $v0 = l'adresse mémoire exacte où écrire le pixel
GetAddress:
	sll $t0, $a0, 2			# Multiplie X par 4
	sll $t1, $a1, 8			# Multiplie Y par 64*4 (512/8= 64 * 4 words)
	add $t2, $t0, $t1		# Additionne les deux 
	addi $v0, $t2, 0x10040000	# Ajout de l'adresse pointé par Bitmap (heap) 
	jr $ra

# Procedure: GetColor
# Input - $a2 = Index dans Colors (0-5)
# Output - $v1 = valeur Hexadécimale
# Retourne la valeur Hexadécimale de la couleur demandée
GetColor:
	la $t0, Colors		
	sll $a2, $a2, 2		
	add $a2, $a2, $t0	
	lw $v1, ($a2)		
	jr $ra

################################   Fin des procédures d'affichage ################################  

################################ Début UpdateRecord ################################ 

# Procedure: UpdateRecord
# Input: Index donné par l'utilisateur - $v0
# Input: Numéro du joueur (1 ou 2) - $a0
# Output: numéro du carré ($v0)
# Détermine la position exacte où placer le jeton et met à jour l'état du jeu en mémoire, puis renvoit la position de jeton

UpdateRecord:
        # Vérifie si l'indice est entre [1 ... 7]
	addiu $v0, $v0, -8             #  Ajoute 8 à indice (Add Imm. Unsigned)
	bltu $v0, -7, DepassementColonne      # Si (indice + 8) est plus petit que -7 alors ça veut dire que l'indice est inferieur à 1 donc saut à l'adresse DepassementColonne (Branch Less Than Unsigned) 
	bgtu $v0, -1, DepassementColonne      # Si (indice + 8) est plus grand que -1 alors ça veut dire que l'indice est supérieur à 7 donc saut à l'adresse DepassementColonne (Branch Greater Than Unsigned) 
	
	# Trouvez la prochaine ligne vide 
	verifierSuivant:
	addiu $v0, $v0, 7	            # Pour aller à la prochaine ligne on ajoute 7
	bgt $v0, 41, DepassementLigne       # On vérifie s'il y a un dépassement de ligne du tableau après l'ajoute de 7 
	lb $t1, grilleJeu($v0)	            # Charger la valeur de la grilleJeu en position $v0 dans $t1 (Load Byte)
	bnez $t1, verifierSuivant	    # Si cette valeur n'est pas nulle, refaire verifierSuivant (branch to label if (r1) != 0)
	
	# Ajouter numéros du joueur
	sb $a0, grilleJeu($v0)	        # Stocker le numéros du joueur dans la grilleJeu en position $v0 (Store byte)
	jr $ra	                        # Finir (Jump Register)
	 
	# Affiche: la colonne est pleinne
	DepassementLigne:
	move $t0, $a0              # On met la valeur de $a0 dans un registre temporaire $t0 pour le moment car on veut utiliser le registre $a0
	la $a0, displayFull        
	li $v0, 4                  # Affiche: la colonne choisie est pleinne
	syscall
	move $a0, $t0              # On récupère la valeur qui est $t0 et on le met dans $a0
	
	# Affiche: resaisir l'indice
	DepassementColonne:
	move $t0, $a0               # On met la valeur de $a0 dans un registre temporaire $t0 pour le moment car on veut utiliser le registre $a0
	la $a0, displayInstructions 
	li $v0, 4                   # Affiche: Choisissez un nombre entre 1 et 7 (inclus)
	syscall
	move $a0, $t0               # On récupère la valeur qui est $t0 et on le met dans $a0
	j retournJoueur             # Saut vers retournJoueur
	
	retournJoueur:
	beq $a0, 1, playerOne # Si la valeur de $a0 est égale à 1 alors saut à l'adresse playerOne
	beq $a0, 2, playerTwo # Si la valeur de $a0 est égale à 2 alors saut à l'adresse playerTwo
	
################################ Fin UpdateRecord ###############################
		
################################ Début WinCheck ################################  

# Procedure: WinCheck
# Input: Index donné par l'utilisateur - $v0
# Input: Numéro du joueur (1 ou 2) - $a0
# Détermine si le dernier jeton joué a permis de gagner
WinCheck:    	
     	
     	addiu $sp, $sp, -4              # Alloue un mot dans la pile 
     	sw $ra, ($sp)                   # Sauvegarde l'adresse de retour        
     	
        li $t8, 7			# On met 7 dans $t8 qui permettre de faire modulo par la suite pour vérifier si on est tout à gauche ou tout à droite
          	 	
    	################################ Debut vérifie horizontal ################################
     	# Aller vers la gauche 
	li $t9, 1			# Le compteur s'il atteint 4 le joueur à gagner
	move $t2, $v0		        # La position du jeton qui vient d'être jouer sera dans $t2 pour la recherche à GAUCHE
	move $t4, $v0		        # La position du jeton qui vient d'être jouer sera dans $t4 pour la recherche à DROITE
		
	verifieGauche:
	la $t0, grilleJeu($t2)	        # Charger l'adresse du jeton actuel 
			
	# Si on est tout à gauche, on continue à droite
	div $t2, $t8                    # La position diviser par 7
	mfhi $t3			# Mettre le reste de la division par 7 dans $t3
	beqz $t3, verifieDroite	        # Si le resultat est égale O alors, on vas vérifier à droite
			
	# Sinon on va à la position à gauche 
	lb $t1, -1($t0)			# A Gauche de la position actuelle 
	bne $t1, $a0, verifieDroite	# Si la valeur n'est pas égale au numéro du joueur alors, on vas vérifier à droite
	addiu $t9, $t9, 1		# Sinon on incrément le compteur  
	addiu $t2, $t2, -1              # On se met à gauche 
	bgt $t9, 3, PlayerWon		# Si le compteur est supérieur à 3 alors, le joueur à gagner
	j verifieGauche                 # Continuer la boucle
			
	# Aller à droite
	verifieDroite:
	la $t0, grilleJeu($t4)          # Charger l'adresse du jeton actuel
		
	# Si on est tout à droit, on arrêt 
	div $t4, $t8                            # La position diviser par 7
	mfhi $t3                                # Mettre le reste de la division par 7 dans $t3
	beq $t3, 6, finVerifieHorizontale	# Si le resultat de modulo égale à 6 c'est la fin de la ligne horizontale alors, on arrêt
		
	# Sinon on va à la position à notre gauche 
	lb $t1, 1($t0)		                # A droite de la position actuelle 
	bne $t1, $a0, finVerifieHorizontale	# Si la valeur n'est pas égale au numéro du joueur, on arrêt 
	addiu $t9, $t9, 1	        # Sinon on incrément le compteur 
	addiu $t4, $t4, 1	        # On se met à droite
	bgt $t9, 3, PlayerWon	        # Si le compteur est supérieur à 3 alors, le joueur à gagné 
	j verifieDroite			# Continuer la boucle
		
	finVerifieHorizontale:
	################################ Fin vérifie horizontal ################################
     	
     	
        ################################# Debut Vérifie vertical ################################
    	# On va vers le haut 
     	li $t9, 1		        # Le compteur s'il atteint 4 le joueur à gagné
	move $t2, $v0		        # La position du jeton qui vient d'être jouer sera dans $t2 pour la recherche en haut 
	move $t4, $v0		        # La position du jeton qui vient d'être jouer sera dans $t4 pour la recherche en bas
	  	
       	verifieHaut:
     	la $t0, grilleJeu($t2)	        # Charger l'adresse du jeton actuel 
     	
      	# Si on est à la dernière ligne en haut on va vérifier en bas 
     	bgtu $t2, 34, verifieBas	# Si notre position est supérieure à 34 alors, on est à la dernière ligne en haut alors, on vérifie en bas 
     		
    	# Sinon on va dans les positions au dessus
    	lb $t1, 7($t0)			# En haut de la position actuelle
    	bne $t1, $a0, verifieBas	# Si la valeur n'est pas égale au numéro du joueur alors on vas vérifier en Bas
    	addiu $t9, $t9, 1		# Sinon on incrément le compteur 
        addiu $t2, $t2, 7               # On se met en haut
	bgt $t9, 3, PlayerWon		# Si le compteur est supérieur à 3 alors, le joueur à gagné
     	j verifieHaut			# Continuer la boucle
      	
       	# On va vers le bas                    
	verifieBas:
	la $t0, grilleJeu($t4)                  # Charger l'adresse du jeton actuel
	 
	# Si on est à la derniere ligne en bas on va vérifier en haut 
	bltu $t4, 7, finVerifieVertical         # Si notre position est inférieure à 7 alors, on est à la dernière ligne en bas alors, on arrêt la vérification
	
	# Sinon on regard la position en dessous
	lb $t1, -7($t0)		                # En haut de la position actuelle
	bne $t1, $a0, finVerifieVertical	# Si la valeur n'est pas égale au numéro du joueur alors, on arrêt la vérification
	addiu $t9, $t9, 1                       # Sinon on incrément le compteur 
	addiu $t4, $t4, -7	                # On se met en bas 
	bgt $t9, 3, PlayerWon	                # Si le compteur est supérieur à 3 alors, le joueur à gagné  
	j verifieBas                            # Continuer la boucle
	
	finVerifieVertical:  
	################################# Fin Vérifie vertical ################################
	
			
			
	################################# Debut vérifie slash ################################
	
     	li $t9, 1		        # Le compteur s'il atteint 4 le joueur à gagner
	move $t2, $v0		        # La position du jeton qui vient d'être jouer sera dans $t2 pour la recherche en haut à droite 
	move $t4, $v0		        # La position du jeton qui vient d'être jouer sera dans $t4 pour la recherche en bas à gauche
	
	# On vas en haut à droite	
	verifieHautDroite:
	la $t0, grilleJeu($t2)	        # Charger l'adresse actuelle du jeton
			
	# Si on est à tout en haut ou on est tout à droite alors on va vérifier en bas à gauche
	bgtu $t2, 34, verifieBasGauche	# Si notre position est supérieure à 34 alors, on est à la dernière ligne en haut alors on vérifie en bas à gauche 
	div $t2, $t8                    # La position diviser par 7 
	mfhi $t3                        # Mettre le reste de la division par 7 dans $t3 
	beq $t3, 6, verifieBasGauche	# Si $t3 égale à 6 alors, on est tout à droite alors on va vérifier en bas à gauche 
			
	# Sinon on vas en haut à droite 
	lb $t1, 8($t0)			# En haut à droite de la position initiale
	bne $t1, $a0, verifieBasGauche  # Si la valeur n'est pas égale au numéro du joueur on va en bas à gauche
	addiu $t9, $t9, 1		# Sinon on incrément le compteur 
	addiu $t2, $t2, 8               # On se met en haut à droite
	bgt $t9, 3, PlayerWon	     	# Si le compteur est supérieur à 3 alors le joueur à gagné 
	j verifieHautDroite             # Continuer la boucle 
			
	# On vas en bas à gauche
	verifieBasGauche:
	la $t0, grilleJeu($t4)          # Charger l'adresse du jeton actuel
		
	# Si on est tout en bas ou tout à gauche alors on arrêt de vérifier 
	bltu $t4, 7, finSlash	        # Si notre position est inférieur à 7 alors on est à la dernière ligne en bas alors on arrêt la vérification 
	div $t4, $t8  			# La position diviser par 7 
	mfhi $t3                        # Mettre le reste de la division par 7 dans $t3
	beq $t3, 0, finSlash	        # Si $t3 égale à 0 alors on est tout à gauche alors on arrêt la vérification
		
	# Sinon on vas en bas à gauche
	lb $t1, -8($t0)		        # En bas à gauche de la position initiale
	bne $t1, $a0, finSlash	        # Si la valeur n'est pas égale au numéro du joueur alors, on arrêt la vérification
	addiu $t9, $t9, 1	        # Sinon on incrément le compteur
	addiu $t4, $t4, -8	        # On se met en bas à gauche
	bgt $t9, 3, PlayerWon        	# Si le compteur est supérieur à 3 alors, le joueur à gagné 
	j verifieBasGauche		# Continuer la boucle
		
	finSlash:  
	################################# Fin vérifie slash ################################
			
		
	################################# Début vérifie anti slash ################################
	
	li $t9, 1		       # Le compteur s'il atteint 4 le joueur a gagné
	move $t2, $v0	               # La position du jeton qui vient d'être jouer sera dans $t2 pour la recherche en haut à droite 
	move $t4, $v0		       # La position du jeton qui vient d'être jouer sera dans $t4 pour la recherche en bas à gauche
	
	# On vas en haut à gauche
	verifieHautGauche:
	la $t0, grilleJeu($t2)	       # Charger l'adresse du jeton actuelle 
	
        # Si on est à tout en haut ou on est tout à gauche alors, on vas vérifier en bas à droite		
	bgtu $t2, 34, verifieBasDroite # Si notre position est supérieure à 34 alors, on est à la dernière ligne en haut alors on vérifie en bas droite
	div $t2, $t8                   # La position diviser par 7 
	mfhi $t3                       # Mettre le reste de la division par 7 dans $t3 
	beq $t3, 0, verifieBasDroite   # Si $t3 égale à 0 alors on est tout à gauche alors on vérifie en bas droite
			
	#Sinon on vas en haut à gauche  
	lb $t1, 6($t0)		       # En haut à gauche de la position initiale
	bne $t1, $a0, verifieBasDroite # Si la valeur n'est pas égale au numéro du joueur alors, on va en bas à droite 
	addiu $t9, $t9, 1	       # Sinon on incrément le compteur
	addiu $t2, $t2, 6              # On se met en haut à gauche 
	bgt $t9, 3, PlayerWon	       # Si le compteur est supérieur à 3 alors, le joueur à gagné
	j verifieHautGauche            # Continuer la boucle
			
	# On vas en bas à droite
	verifieBasDroite:
	la $t0, grilleJeu($t4)         # Charger l'adresse du jeton actuel
		
	# Si on est tout en bas ou on est tout à droit alors on arrêt de vérifier
	bltu $t4, 7, finAntiSlash	 # Si notre position est inférieur à 7 alors, on est à la dernière ligne en bas alors alors, on arrêt la vérification 
	div $t4, $t8		          # La position diviser par 7 
	mfhi $t3                          # Mettre le reste de la division par 7 dans $t3
	beq $t3, 6, finAntiSlash	  # Si $t3 égale à 6 alors on est tout à droite alors on arrêt la vérification
		
	# Sinon on vas en bas a droite
	lb $t1, -6($t0)		          # En bas à droite de la position initiale
	bne $t1, $a0, finAntiSlash	  # Si la valeur n'est pas égale au numéro du joueur alors, on arret
	addiu $t9, $t9, 1	          # Sinon on incrément le compteur
	addiu $t4, $t4, -6	          # On se met en bas à droite 
	bgt $t9, 3, PlayerWon	          # Si le compteur est supérieur à 3 alors le joueur a gagné
	j verifieBasDroite                # Continuer la boucle
		
	finAntiSlash:     	
	################################# Fin vérifie anti slash ###############################
			
	################################# Début vérifie plein #################################
	li $t9, 35		           # On se met tout en haut du tableau
	la $t0, grilleJeu($t9)	           # Charger l'adresse du jeton actuel
	li $t2, 0		           # Compteur pour le nombre de jeton 
	
	verifiePlein:
	lb $t1, ($t0)	            # En position initiale
	beq $t1, 0, finEgaliter	    # Si la valeur de $t1 égale à 0 on arrêt de vérifier
	add $t2, $t2, 1	            # Sinon on incrément le compteur
	addi $t0, $t0, 1            # On se met à droite
	beq $t2, 7, GameTie         # Si le compteur est égale à 7 alors, la ligne tout en haut remplie donc égalité!
	j verifiePlein		    # Continuer la boucle
		
	finEgaliter:
	################################# Fin vérifie plein #################################
		
	lw $ra, ($sp)               # Retourner l'adresse
	addiu $sp, $sp, 4	    # Libérer la case allouée de la pile  
	jr $ra	                    # Retourner
		

################################  End WinCheck ################################ 

# Procedure: GameTie
# Affiche l'égalité et arrêt de jeu
GameTie:
	la $a0, displayTie
	li $v0, 4              # Affiche: Il y a l'égalité
	syscall
		
	la $a0, displayRestart 
	li $v0, 4	       # Affiche: Voulez-vous recommencer le jeu ? si oui, saisissez 1 sinon, 0
	syscall
		
	li $v0, 5              # Lecture de la saisie pour recommencer (1 ou 0)
	syscall
	move $t0, $v0           # Mettre la saisie dans $t0
	bgt $v0, 1, DepassementRestart  # Si le $v0 est supérieur à 1 alors ce n'est pas un numéro pour recommencer le jeu ou non saut vers l'adresse DepassementRestart 
	blt $v0, 0, DepassementRestart  # Si le $v0 est infèrieur à 0 alors ce n'est pas un numéro pour recommencer le jeu ou non saut vers l'adresse DepassementRestart
	beq $t0 1 Restart      # Si $t0 égale à 1 alors saut vers l'adresse Restart
		
	li $v0, 10             # Terminer le programme
	syscall


# Procedure: PlayerWon
# Input: $a0 - Player Number
# Affiche: le gagnant et arrêt du jeu
PlayerWon:

	beq $a0, 2, joueur2Gagne	# Si le numéro de joueur est égale à 2 alors on saut vers l'adresse joueur1Gagne
	
        #Player 1 Won		
	la $a0, displayP1Win
	li $v0, 4               # Affiche: Le joueur 1 a gagné
	syscall
		
	la $a0, displayRestart 
	li $v0, 4	       # Affiche: Voulez-vous recommencer le jeu? si oui, saisissez 1 sinon, 0
	syscall
		
	li $v0, 5              # Lecture de la saisie pour recommencer (1 ou 0)
	syscall
	move $t0 $v0           # Mettre la saisie dans $t0
	bgt $v0, 1, DepassementRestart1  # Si le $v0 est supérieur à 1 alors ce n'est pas un numéro pour recommencer le jeu ou non saut vers l'adresse DepassementRestart1
	blt $v0, 0, DepassementRestart1  # Si le $v0 est infèrieur à 0 alors ce n'est pas un numéro pour recommencer le jeu ou non saut vers l'adresse DepassementRestart1
	beq $t0, 1, Restart      # Si $t0 égale à 1 alors saut vers l'adresse Restart
		
	li $v0, 10             # Terminer le programme
	syscall
		
	#Player 2 Won
	joueur2Gagne:	
	la $a0, displayP2Win
	li $v0, 4	       # Affiche Le joueur 2 a gagné
	syscall

	la $a0, displayRestart 
	li $v0, 4	       # Affiche: Voulez-vous recommencer le jeu? si oui saisissez 1 sinon, 0
	syscall
		
	li $v0, 5              # Lecture de la saisie pour recommencer (1 ou 0)
	syscall
	move $t0, $v0           # Mettre la saisie dans $t0
	bgt $v0, 1, DepassementRestart2  # Si le $v0 est supérieur à 1 alors ce n'est pas un numéro pour recommencer le jeu ou non saut vers l'adresse DepassementRestart2
	blt $v0, 0, DepassementRestart2  # Si le $v0 est infèrieur à 0 alors ce n'est pas un numéro pour recommencer le jeu ou non saut vers l'adresse DepassementRestart2
	beq $t0, 1, Restart      # Si $t0 égale à 1 alors saut vers l'adresse Restart
		
	li $v0, 10	       # Terminer le programme
	syscall
		
	DepassementRestart:
	la $a0, displayRestartInstruction 
	li $v0, 4	       # Affiche: Ce numéro n'est pas un numéro pour recommencer le jeu ou non, veuillez saisir 1 pour recommencer le jeu, sinon 0.
	syscall
	jal GameTie            # Continuer la boucle
	
        DepassementRestart1:
        la $a0, displayRestartInstruction 
	li $v0, 4	       # Affiche: Ce numéro n'est pas un numéro pour recommencer le jeu ou non, veuillez saisir 1 pour recommencer le jeu, sinon 0.
	syscall
        jal PlayerWon          # Continuer la boucle
        
        DepassementRestart2:
        la $a0, displayRestartInstruction 
	li $v0, 4	       # Affiche: Ce numéro n'est pas un numéro pour recommencer le jeu ou non, veuillez saisir 1 pour recommencer le jeu sinon, 0.
	syscall
        jal joueur2Gagne       # Continuer la boucle



# Procedure: Restart
# Input: $a0 - Player Number
# Effacer les jetons du tableau puis, relancer le jeu 
Restart: 	

	add $v0 $zero $zero   # Ajoute O à l'indice du tableau
	li $a0,0              # Mettre 0 dans $a0 
      	sb $a0, grilleJeu($v0) # Remplir le tableau à 0 à l'indice $v0
	li $a0,6              # Mettre 6 dans $a0 
        jal DrawPlayerChip    # Dessiner le jeton blanc
        	
        dessine:
        add $v0 $v0 1         # Ajouter 1 pour aller à l'indice suivant 
      	li $a0,6	      # Mettre 6 dans $a0 
      	jal DrawPlayerChip    # Dessiner le jeton blanc
      	li $a0,0	      # Mettre 0 dans $a0 
      	sb $a0, grilleJeu($v0) # Remplir le tableau à 0 à l'indice $v0
     	bgt $v0, 40, goStart    # Si $v0 est supérieur à 40 alors, on saut vers l'adresse goStart
      	j dessine             # Continuer la boucle
      	
        goStart:             	
       	jal choisirCouleur    # On saut vers l'adresse choisirCouleur pour recommencer le jeu 

# Fin du projet, Seyedehsetayesh GHAMAT et King LAU
		
		



